# class OptionParser::AC

### Constants

ARG_CONV

### Public Instance Methods

ac_arg_disable(name, help_string, &block) click to toggle source

    # File lib/optparse/ac.rb, line 38
    def ac_arg_disable(name, help_string, &block)
      _ac_arg_enable("disable", name, help_string, block)
    end

ac_arg_enable(name, help_string, &block) click to toggle source

    # File lib/optparse/ac.rb, line 34
    def ac_arg_enable(name, help_string, &block)
      _ac_arg_enable("enable", name, help_string, block)
    end

ac_arg_with(name, help_string, &block) click to toggle source

    # File lib/optparse/ac.rb, line 42
    def ac_arg_with(name, help_string, &block)
      _check_ac_args(name, block)

      sdesc = []
      ldesc = ["--with-#{name}"]
      desc = [help_string]
      q = name.downcase
      with = Switch::PlacedArgument.new(*search(:atype, String), sdesc, ldesc, nil, desc, block)
      without = Switch::NoArgument.new(nil, proc {}, sdesc, ldesc, nil, desc, block)
      top.append(with, [], ["with-" + q], without, ['without-' + q])
      with
    end

### Private Instance Methods

_ac_arg_enable(prefix, name, help_string, block) click to toggle source

    # File lib/optparse/ac.rb, line 18
    def _ac_arg_enable(prefix, name, help_string, block)
      _check_ac_args(name, block)

      sdesc = []
      ldesc = ["--#{prefix}-#{name}"]
      desc = [help_string]
      q = name.downcase
      ac_block = proc {|val| block.call(ARG_CONV.call(val))}
      enable = Switch::PlacedArgument.new(nil, ARG_CONV, sdesc, ldesc, nil, desc, ac_block)
      disable = Switch::NoArgument.new(nil, proc {false}, sdesc, ldesc, nil, desc, ac_block)
      top.append(enable, [], ["enable-" + q], disable, ['disable-' + q])
      enable
    end

_check_ac_args(name, block) click to toggle source

    # File lib/optparse/ac.rb, line 7
    def _check_ac_args(name, block)
      unless /\A\w[-\w]*\z/ =~ name
        raise ArgumentError, name
      end
      unless block
        raise ArgumentError, "no block given", ParseError.filter_backtrace(caller)
      end
    end